﻿@page "/thumbnail"
@model PommaLabs.Thumbnailer.Server.Pages.ThumbnailModel
@{
    ViewData["Title"] = "Thumbnail generation";
    ViewData["RequestUrl"] = Request.GetDisplayUrl();
}

<div class="row">
    <div class="col text-center">
        <h1>Thumbnail generation</h1>
    </div>
</div>

<div class="row">
    <div class="col">
        <!form id="thumbnailer-dropzone" action="/api/v1/thumbnail?responseType=base64" method="post"
              class="dropzone dz-clickable">
            <div class="dz-message d-flex flex-column">
                <span class="th-upload-icon">&#9729;</span>
                Drag &amp; Drop here or click to start generating file thumbnails.
            </div>
        </!form>
    </div>
</div>

<!form id="params" class="row">
    <div class="col d-flex justify-content-around flex-wrap">
        <div class="form-group">
            <label for="widthPx">Width (px)</label>
            <input type="number" class="form-control" id="widthPx" value="256" min="16" max="1024" />
        </div>
        <div class="form-group">
            <label for="heightPx">Height (px)</label>
            <input type="number" class="form-control" id="heightPx" value="256" min="16" max="1024" />
        </div>
        <div class="form-group">
            <label for="shavePx">Shave (px)</label>
            <input type="number" class="form-control" id="shavePx" value="0" min="0" max="64" />
        </div>
        <div class="form-group">
            <label for="fill">Fill</label>
            <div class="form-check form-switch th-switch">
                <input class="form-check-input" type="checkbox" role="switch" id="fill" checked>
            </div>
        </div>
        <div class="form-group">
            <label for="smartCrop">Smart crop</label>
            <div class="form-check form-switch th-switch">
                <input class="form-check-input" type="checkbox" role="switch" id="smartCrop">
            </div>
        </div>
        <div class="form-group">
            <label for="fallback">Fallback</label>
            <div class="form-check form-switch th-switch">
                <input class="form-check-input" type="checkbox" role="switch" id="fallback">
            </div>
        </div>
    </div>
</!form>

<div class="row">
    <div class="col-6 offset-3 text-center">
        <!form id="fair-use-token-to-api-key-form" class="d-inline-flex">
            @Html.AntiForgeryToken()
            <input type="hidden" id="fair-use-token" name="token" />
            <button id="fair-use-token-to-api-key-submit" type="button" class="btn btn-primary btn-lg" disabled
                    onclick="onFairUseTokenToApiKeyButtonClick(); return false;">
                Generate!
            </button>
        </!form>
    </div>
</div>

<div class="row">
    <div class="col th-text-block">
        <h2>What is thumbnail generation?</h2>
        <p>
            Thumbnail generation is about getting a representative (and small) image of a given file.
            For example, an image of the first page of a PDF file or a scaled-down version of an HD photo.
        </p>
        <p>
            Thumbnails can be used to implement file galleries on custom content management systems.
        </p>
    </div>
</div>

@section Scripts {
    <script>
        window.appData.operationType = "ThumbnailGeneration";

        // Auto save form data:
        $('#params').sisyphus();

        function updateThumbnailParams(key, value) {
            var action = new URL($("#thumbnailer-dropzone").prop("action"));
            action.searchParams.set(key, value);
            $("#thumbnailer-dropzone").prop("action", action);
        }

        $(function () {
            $("#widthPx").change(function () {
                updateThumbnailParams("widthPx", $(this).val());
            });
            $("#heightPx").change(function () {
                updateThumbnailParams("heightPx", $(this).val());
            });
            $("#shavePx").change(function () {
                updateThumbnailParams("shavePx", $(this).val());
            });
            $("#fill").change(function () {
                updateThumbnailParams("fill", $(this).prop("checked"));
            });
            $("#smartCrop").change(function () {
                updateThumbnailParams("smartCrop", $(this).prop("checked"));
            });
            $("#fallback").change(function () {
                updateThumbnailParams("fallback", $(this).prop("checked"));
            });

            // Set values after Sisyphus has restored inputs:
            updateThumbnailParams("widthPx", $("#widthPx").val());
            updateThumbnailParams("heightPx", $("#heightPx").val());
            updateThumbnailParams("shavePx", $("#shavePx").val());
            updateThumbnailParams("fill", $("#fill").prop("checked"));
            updateThumbnailParams("smartCrop", $("#smartCrop").prop("checked"));
            updateThumbnailParams("fallback", $("#fallback").prop("checked"));
        });
    </script>
}
